#pragma once

#include "Ray.h"

class Material {
  public:
    Material();
    glm::vec3 ambient;
    glm::vec3 diffuse;
    glm::vec3 specular;	
    float glossiness;
    float reflection;
};

class Object {
  public:
    Object(const glm::mat4 &transform = glm::mat4(1.0f), const Material &material = Material());

    virtual bool Intersect(const Ray &ray, IntersectInfo &info) const { return true; }

    glm::vec3 Position() const { return glm::vec3(transform[3][0], transform[3][1], transform[3][2]); }

    const Material *MaterialPtr() const { return &material; }

  protected:
    glm::mat4 transform;
    Material material;
};

/* TODO: Implement */
class Sphere : public Object {
  public:
    virtual bool Intersect(const Ray &ray, IntersectInfo &info) const;
};

/* TODO: Implement */
class Plane : public Object {
  public:
    virtual bool Intersect(const Ray &ray, IntersectInfo &info) const;
};

/* TODO: Implement */
class Triangle : public Object {
  public:
    virtual bool Intersect(const Ray &ray, IntersectInfo &info) const;
};
