#ifndef RayTracer_h
#define RayTracer_h

#define _USE_MATH_DEFINES
#include <cmath>
#include <vector>
#include <iostream>
#include <fstream>
#include <cstring>

#include <GL/glut.h>

#include "glm/glm.hpp"
#include "glm/gtc/matrix_transform.hpp"

#include "Ray.h"
#include "Object.h"

bool CheckIntersection(const Ray &ray, IntersectInfo &info);
float CastRay(Ray &ray, Payload &payload);

/* Allows you to stream glm::vec3 objects to the terminal. */
std::ostream& operator << (std::ostream &stream, const glm::vec3 &obj) {
	stream << obj.x << ' ' << obj.y << ' ' << obj.z << ' ';
	return stream;
}

/* Three way max and min */
float fmax(float f1,float f2, float f3) {
	float f = f1;
	if (f < f2) f = f2;
	if (f < f3) f = f3;
	return f;
}

float fmin(float f1,float f2, float f3) {
	float f = f1;
	if (f > f2) f = f2;
	if (f > f3) f = f3;
	return f;
}

/* Comparison operator for vectors */
bool operator >(const glm::vec3 &lhs, const glm::vec3 &rhs){
	if( lhs.x > rhs.x && lhs.y > rhs.y && lhs.z > rhs.z ){
    return true;
	}
  return false;
}

bool operator <(const glm::vec3 &lhs, const glm::vec3 &rhs){
	if( lhs.x < rhs.x && lhs.y < rhs.y && lhs.z < rhs.z ){
    return true;
	}
  return false;
}

#endif